#include <Adafruit_NeoPixel.h>

#define PIN D10 // Pin connected to the DIN of WS2812B
#define NUMPIXELS 140 // Number of LEDs in the strip
#define TRIG_ECHO_PIN D9 // Pin connected to the Trig/Echo pin of the ultrasonic sensor

Adafruit_NeoPixel strip = Adafruit_NeoPixel(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);

void setup() {
  strip.begin();
  strip.show(); // Initialize all pixels to 'off'
  pinMode(TRIG_ECHO_PIN, OUTPUT);
}

void loop() {
  long duration, distance;
  pinMode(TRIG_ECHO_PIN, OUTPUT);
  digitalWrite(TRIG_ECHO_PIN, LOW);
  delayMicroseconds(2);
  digitalWrite(TRIG_ECHO_PIN, HIGH);
  delayMicroseconds(10);
  digitalWrite(TRIG_ECHO_PIN, LOW);
  pinMode(TRIG_ECHO_PIN, INPUT);
  duration = pulseIn(TRIG_ECHO_PIN, HIGH);
  distance = (duration / 2) / 29.1; // Convert to distance in cm


  if (distance <= 60) {
    setStripColor(strip.Color(255, 0, 0)); // Red color
  } else if (distance <= 140) {
    setStripColor(strip.Color(255, 255, 0)); // Yellow color
  } else if (distance <= 210) {
    setStripColor(strip.Color(0, 255, 0)); // Green color
  } else {
    setStripColor(strip.Color(0, 0, 0)); // Turn off LEDs
  }
  delay(500);
}

void setStripColor(uint32_t color) {
  for(int i=0; i<strip.numPixels(); i++) {
    strip.setPixelColor(i, color);
  }
  strip.show();
}

